import ChevronRightIcon from '@/assets/vectors/icons/chevron-right.svg?component';
import ChevronLeftIcon from '@/assets/vectors/icons/chevron-left.svg?component';
import ChevronUpIcon from '@/assets/vectors/icons/chevron-up.svg?component';
import ChevronDownIcon from '@/assets/vectors/icons/chevron-down.svg?component';
import PlusIcon from '@/assets/vectors/icons/plus.svg?component';
import ArrowIcon from '@/assets/vectors/icons/arrow.svg?component';
import DotsIcon from '@/assets/vectors/icons/dots.svg?component';

type Name =
  | 'chevron-right'
  | 'chevron-left'
  | 'chevron-up'
  | 'chevron-down'
  | 'plus'
  | 'arrow'
  | 'dots';

export interface IconProps {
  className?: string;
  name?: Name;
}

const icons = {
  'chevron-right': ChevronRightIcon,
  'chevron-left': ChevronLeftIcon,
  'chevron-up': ChevronUpIcon,
  'chevron-down': ChevronDownIcon,
  plus: PlusIcon,
  arrow: ArrowIcon,
  dots: DotsIcon,
} as const;

export const Icon = ({ name = 'chevron-right', className = '' }: IconProps): JSX.Element => {
  const IconComponent = icons[name] || ChevronRightIcon;

  return <IconComponent className={className} />;
};

Icon.displayName = 'Icon';
